%global debug_package %{nil}

Name:           tsung
Version:        1.8.0
Release:    1%{?dist}
Summary:        A distributed multi-protocol load testing tool
License:        GPL-2.0-only
URL:            http://tsung.erlang-projects.org/
Source0:        http://tsung.erlang-projects.org/dist/%{name}-%{version}.tar.gz

BuildRequires: make
BuildRequires:  erlang
BuildRequires:  perl-generators
BuildRequires:  python3-devel
BuildRequires:  python3-sphinx
BuildRequires:  latexmk
BuildRequires:  texlive-titlesec
BuildRequires:  texlive-framed
BuildRequires:  texlive-threeparttable
BuildRequires:  texlive-wrapfig
BuildRequires:  texlive-fncychap
Requires:       erlang
Requires:       gnuplot
Requires:       perl-Template-Toolkit

%description
tsung is a distributed load testing tool. It is protocol-independent and can 
currently be used to stress and benchmark HTTP, Jabber/XMPP, PostgreSQL, 
MySQL and LDAP servers.

It simulates user behavior using an XML description file, reports many 
measurements in real time (statistics can be customized with transactions, 
and graphics generated using GnuPlot).

For HTTP, it supports 1.0 and 1.1, has a proxy mode to record sessions, 
supports GET and POST methods, Cookies, and Basic WWW-authentication.
 
It also has support for SSL.

%package doc
BuildArch:      noarch
Summary:        Documentation files for tsung

%description doc
Documentation files for tsung

%prep
%setup -qn %{name}-%{version}

sed -i 's|/usr/bin/env bash|/bin/bash|' *.sh.in
sed -i 's|/usr/bin/env python|/usr/bin/python|' src/tsung-plotter/tsplot.py.in
sed -i '/SPHINXBUILD/ s|sphinx-build|sphinx-build-3|' docs/Makefile
sed -i 's|/usr/bin/env perl|/usr/bin/perl|' src/log2tsung.pl.in
for file in LISEZMOI
do
    iconv -f ISO-8859-1 -t UTF-8 $file > $file.utf8
    touch -r $file $file.utf8
    mv -f $file.utf8 $file
done

%build
%configure --prefix=/usr
%make_build

%install
%make_install

for i in `ls %{buildroot}%{_libdir}/%{name}/bin | grep .pl$ | cut -d"." -f1`
do
  ln -sf ../%{_lib}/%{name}/bin/$i.pl %{buildroot}%{_bindir}/$i
done

rm -frv %{buildroot}%{_docdir}
rm -frv examples/*.xml.in

sed -i 's|python33|python3|' %{buildroot}%{_bindir}/tsplot

%files
%doc CHANGELOG.md CONTRIBUTORS COPYING LISEZMOI README.md TODO
%{_bindir}/%{name}
%{_bindir}/%{name}-rrd
%{_bindir}/%{name}_percentile
%{_bindir}/%{name}_stats
%{_bindir}/%{name}-recorder
%{_bindir}/log2%{name}
%{_bindir}/tsplot
%{_datadir}/%{name}
%{_libdir}/%{name}/
%{_mandir}/man1/%{name}.1*
%{_mandir}/man1/%{name}-recorder.1*
%{_mandir}/man1/tsplot.1*

%files doc
%doc docs examples

%changelog
* Fri Sep 06 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.8.0-1
- initial build
